#include "MakPythonViewPrefsWindow.h"
#include <Alert.h>

#define _ABOUT_ 'abut'


MakPythonPrefsWindow::MakPythonPrefsWindow(BRect frame,MakPythonViewWindow *p)
				   :BWindow(frame,"Preferences",B_TITLED_WINDOW,B_NOT_RESIZABLE|B_ASYNCHRONOUS_CONTROLS|B_WILL_DRAW)
{
	parent=p;
	BRect bounds=Bounds();
	bounds.InsetBy(-1,-1);
	
	bg=new BBox(bounds,"box",B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_NO_BORDER);
	
	txt_ops=new BBox(BRect(3,10,110,85),"text_options",B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	txt_ops->SetLabel("Text Options");
	
	wrap_text=new BCheckBox(BRect(7,17,90,16),"wrapper","Wrap Text",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP);
	wrap_text->SetValue(parent->wrap_text);
	boldulise=new BCheckBox(BRect(7,35,90,37),"bolder","Bold Text",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP);
	boldulise->SetValue(parent->font_is_bold);
	indt=new BCheckBox(BRect(7,53,90,37),"indenter","Indent after :",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP);
	indt->SetValue(parent->indented);
	
	exe=new BCheckBox(BRect(7,193,150,194),"exe","Save as Executable script",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP);
	exe->SetValue(parent->exe);
	
	
	path_ops=new BBox(BRect(3,95,210,189),"Path_Options",B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	path_ops->SetLabel("Path Options");
	
	
	shell=new BTextControl(BRect(7,17,200,16),"shell","Path to Shell",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	shell->SetDivider(70);
	shell->SetText(parent->path_to_sh);
	
	Python=new BTextControl(BRect(7,35,200,36),"Path to Python","Path to Python",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	Python->SetDivider(70);
	Python->SetText(parent->path_to_Python);
	
	term=new BTextControl(BRect(7,53,200,54),"Path to term","Terminal",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	term->SetDivider(70);
	term->SetText(parent->path_to_term);
	
	docpath=new BTextControl(BRect(7,71,200,72),"docs","Path to docs",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	docpath->SetDivider(70);
	docpath->SetText(parent->path_to_docs);
	
	About=new BButton(BRect(120,15,200,40),"about","About...",new BMessage(_ABOUT_),B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP);
	
	char temp[2];
	temp[0]=parent->run_key;
	temp[1]=0;
	runner=new BTextControl(BRect(115,55,195,56),"run","Run Key:",NULL,B_FOLLOW_NONE,B_WILL_DRAW|B_FRAME_EVENTS|B_NAVIGABLE_JUMP,B_FANCY_BORDER);
	runner->SetDivider(42);
	runner->SetText(temp);
	
	path_ops->AddChild(shell);
	path_ops->AddChild(Python);
	path_ops->AddChild(term);
	path_ops->AddChild(docpath);
	txt_ops->AddChild(wrap_text);
	txt_ops->AddChild(boldulise);
	txt_ops->AddChild(indt);
	bg->AddChild(exe);
	bg->AddChild(txt_ops);
	bg->AddChild(path_ops);
	bg->AddChild(About);
	bg->AddChild(runner);
	AddChild(bg);
	
}

#include <string.h>

bool MakPythonPrefsWindow::QuitRequested()
{
	parent->Lock();
	parent->run_key=runner->Text()[0];
	parent->font_is_bold=boldulise->Value();
	parent->wrap_text=wrap_text->Value();
	parent->exe=exe->Value();
	parent->indented=indt->Value();
	strcpy(parent->path_to_sh,shell->Text());
	strcpy(parent->path_to_Python,Python->Text());
	strcpy(parent->path_to_term,term->Text());
	strcpy(parent->path_to_docs,docpath->Text());
	parent->RestoreEverything();
	parent->SaveEverything();
	parent->W_Shown=false;
	
	char pathp[B_FILE_NAME_LENGTH+10]="Path: ";
	strcat(pathp,parent->path_to_Python);
	parent->pp->SetText(pathp);

	parent->Unlock();
	return BWindow::QuitRequested();
}

void MakPythonPrefsWindow::MessageReceived(BMessage *message)
{
	switch (message->what)
	{
		case _ABOUT_:
		{	
			BAlert* hAlert = new BAlert("About Box:", 
								"MakPythonView:\n\nA Simple Python Editor\nCreated by Makhno\nmak@imakhno.freeserve.co.uk",	
								"OK", 
								NULL,
								NULL);
			hAlert->SetShortcut(0, B_ESCAPE); 
			hAlert->Go();
			break;
		}
		default:
			BWindow::MessageReceived(message);		
	}
}
