#include "MakPythonViewWindow.h"
#include <Application.h>
#include <cstdlib>
#include <Path.h>
#include <File.h>
#include <FindDirectory.h>
#include <stdio.h>
#include <Directory.h>
#include <ScrollView.h>
#include "Pref_Saver.h"
#include "MakPythonViewPrefsWindow.h"
#include <Alert.h>

MakPythonViewWindow::MakPythonViewWindow(BRect frame,bool w,bool b,bool ind,bool e,char r,char *clops)
				  :BWindow(frame,"MakPythonView",B_DOCUMENT_WINDOW,B_WILL_DRAW, B_ALL_WORKSPACES)
{
	font_is_bold=b;
	wrap_text=w;
	exe=e;
	indented=ind;
	run_key=r;
	W_Shown=false;
	thread_flag=false;
	was_last_saved=false;
	last_saved_as=new BEntry();
	
	BRect bounds= Bounds();
	menubar=new BMenuBar(bounds,"menu_bar");
	filem=new BMenu("File");
	options=new BMenu("Options");
	docs=new BMenu("Documentation");
	menubar->AddItem(filem);
	menubar->AddItem(options);
	menubar->AddItem(docs);
	filem->AddItem(new BMenuItem("Open" B_UTF8_ELLIPSIS,new BMessage(_OPENFILE_),'O'));
	filem->AddItem(new BMenuItem("Save",new BMessage(_SAVEFILE_),'S'));
	filem->AddItem(new BMenuItem("Save As" B_UTF8_ELLIPSIS,new BMessage(_SAVEAS_),0));
	filem->AddItem(new BMenuItem("Exit",new BMessage(_EXIT_),'Q'));
	
	options->AddItem(runner=new BMenuItem("Run",new BMessage(_RUN_Python_),r));
	options->AddItem(new BMenuItem("Clear",new BMessage(_CLEAR_),'M'));
	options->AddItem(new BMenuItem("Preferences" B_UTF8_ELLIPSIS,new BMessage(_PREFS_),'P'));
	
	docs->AddItem(new BMenuItem("Scan for selected word" B_UTF8_ELLIPSIS,new BMessage(_SCAN_),'D'));
	docs->AddItem(new BMenuItem("Open Python Terminal",new BMessage(_TERMINAL_OPEN_),'T'));
	bounds.top+=21;
	bounds.right-=B_V_SCROLL_BAR_WIDTH;
	bounds.bottom-=B_H_SCROLL_BAR_HEIGHT;
	
	bg=new BBox(BRect(0,bounds.bottom,bounds.right,bounds.bottom+B_H_SCROLL_BAR_HEIGHT),"bg",B_FOLLOW_BOTTOM|B_FOLLOW_LEFT_RIGHT,B_WILL_DRAW|B_FRAME_EVENTS,B_NO_BORDER);
	BRect bg_size=bg->Bounds();
	bg_size.right=110;
	clo=new BTextControl(BRect(bg_size),"clo","Options:",clops,NULL,B_FOLLOW_BOTTOM|B_FOLLOW_LEFT);
	clo->SetDivider(40);
	bg_size.right=175;
	bg_size.left=115;
	line_num=new BStringView(BRect(bg_size),"ln","Line: ");

	bg_size.left=bg_size.right;	
	bg_size.right=Bounds().right;
	pp=new BStringView(BRect(bg_size),"ln","Path: ",B_FOLLOW_TOP|B_FOLLOW_LEFT_RIGHT);	

	
	bounds.bottom-=1;
	Pythonview=new NewTextView(indented,bounds,"Pythonview",BRect(5,0,bounds.right-3,Bounds().bottom-bounds.top-B_H_SCROLL_BAR_HEIGHT),B_FOLLOW_ALL,B_WILL_DRAW,line_num);
	Pythonview->SetAutoindent(true);
	
	RestoreEverything();
	

	bg->AddChild(clo);
	bg->AddChild(line_num);
	bg->AddChild(pp);
	AddChild(bg);
	AddChild(menubar);
	AddChild(new BScrollView("Scroller",Pythonview,B_FOLLOW_ALL,0,false,true,B_FANCY_BORDER));	
		
	BPath old;
	if (find_directory(B_USER_SETTINGS_DIRECTORY, &old)==B_OK)
	{
		if (old.Append("MakPythonView")==B_OK)
		{
			if (old.Append("MakPythonView_Script")==B_OK)
			{
				BFile oldPython(old.Path(),B_READ_ONLY);
				if (oldPython.InitCheck()==B_OK)
				{
					int pos=0;
					oldPython.Seek(0,SEEK_SET);
					char *buf,*text,buff;
					off_t size;
					buf=new char[1];
					buff=0;
					oldPython.GetSize(&size);
					while((buff!='\n')&&(pos<size))
					{
						oldPython.Read(buf,1);
						buff=buf[0];
						pos++;
					}		
					delete buf;
					if (size-pos>2)
					{	
						text=new char[size-pos];
						oldPython.Read(text,size-pos);
						text[size-pos-1]=0;
						Pythonview->SetText(text);
						delete text;
					}
				}
			}
		}
	}
	Pythonview->MakeFocus(true);
}

void MakPythonViewWindow::FrameResized(float x,float y)
{
	BRect bounds(Bounds());
	bounds.top+=21;
	bounds.right-=B_V_SCROLL_BAR_WIDTH;
	Pythonview->SetTextRect(BRect(5,0,bounds.right-3,Bounds().bottom-bounds.top));
}

void MakPythonViewWindow::SaveEverything()
{
	BRect *frame=new BRect(Frame());
	Pref_Saver prefs("MakPythonView.Prefs",20);
	
	double *top,*left,*right,*bottom;
	top=new double;
	left=new double;
	right=new double;
	bottom=new double;
	
	*top=frame->top;
	*bottom=frame->bottom;
	*left=frame->left;
	*right=frame->right;
	
	char temp[2];
	temp[1]=0;
	temp[0]=run_key;
	
	char temp2[256];
	strncpy(temp2,clo->Text(),254);
	if (strlen(temp2)>255)
	{
		temp2[255]=0;
		clo->SetText(temp2);
	}
	if (strlen(temp2)<1)
		strcpy(temp2,"@");
	prefs.AddField("top",top);
	prefs.AddField("left",left);
	prefs.AddField("right",right);
	prefs.AddField("bottom",bottom);
	prefs.AddField("wrap text",wrap_text);
	prefs.AddField("Set +x",exe);
	prefs.AddField("Bold?",font_is_bold);
	prefs.AddField("Shell",path_to_sh);
	prefs.AddField("Python",path_to_Python);
	prefs.AddField("Docs",path_to_docs);
	prefs.AddField("Terminal",path_to_term);
	prefs.AddField("Run Key",temp);
	prefs.AddField("Indent?",indented);
	prefs.AddField("CL ops",temp2);
	
	prefs.SaveFile();

	delete top;
	delete left;
	delete right;
	delete bottom;
	delete frame;

	data = new Window_Data();
	data->parent=this;
	data->call_type=true;
	data->RunFlag=false;
	Run_Python(data); //Save the data
	
}
bool MakPythonViewWindow::QuitRequested()
{
	if (W_Shown)
		return 0;
	SaveEverything();
	be_app->PostMessage(B_QUIT_REQUESTED);
	return BWindow::QuitRequested();
}

void MakPythonViewWindow::RestoreEverything()
{
	runner->SetTrigger(run_key); //doesnt work:(
	if (font_is_bold)
		Pythonview->SetFontAndColor(be_bold_font,B_FONT_ALL,NULL);
	else
		Pythonview->SetFontAndColor(be_fixed_font,B_FONT_ALL,NULL);
	Pythonview->SetWordWrap(wrap_text);
	Pythonview->Set_Indent(indented);
}

void MakPythonViewWindow::MessageReceived(BMessage* message)
{
	switch(message->what)
	{
		case _EXIT_:
		{
			QuitRequested();
			break;
		}
		case _CLEAR_:
		{
			Pythonview->SetText("");	
			SetTitle("MakPythonView");
			break;
		}
		case _RUN_Python_:
		{
			if (thread_flag)
			{
				kill_thread(ptn);
				delete data;
				thread_flag=false;
			}
			thread_flag=true;
			data = new Window_Data();
			data->parent=this;
			data->call_type=true;
			resume_thread(ptn=spawn_thread((status_t (*)(void *))Run_Python,"rp",20,data));	
			break;
		}
		case _PREFS_:
		{
			if (!W_Shown)
			{
				float x,y;
				x=(Frame().left+Frame().right)/2;
				y=(Frame().top+Frame().bottom)/2;
				float w,h;
				w=105;
				h=105;
				W_Shown=true;
				MakPythonPrefsWindow *fprefs=new MakPythonPrefsWindow(BRect(x-w,y-h,x+w,y+h),this);
				fprefs->Show();
			}
			break;
		}	
		case _SCAN_:
		{
			int32 st,fn;
			if (thread_flag)
			{
				kill_thread(dcs);
				delete data;
				thread_flag=false;
			}
			thread_flag=true;
			data = new Window_Data();
			data->parent=this;
			data->call_type=false;		
			Pythonview->GetSelection(&st,&fn);
			Pythonview->GetText(st,fn-st,data->keyword);
			if (data->keyword[0]==0)
			{
				delete data;
				thread_flag=false;
				return;
			}
			resume_thread(dcs=spawn_thread((status_t (*)(void *))Run_Python,"Rundocs",20,data));
			break;
		}
		case _TERMINAL_OPEN_:
		{
			if (thread_flag)
			{
				kill_thread(trm);
				delete data;
				thread_flag=false;
			}
			thread_flag=true;
			data = new Window_Data(); 
			data->parent=this;
			resume_thread(trm=spawn_thread((status_t (*)(void *))Run_Term,"Run Term",15,data));
			break;
		}
		case _OPENFILE_:
		{
			if (!opendlg)
			opendlg=new BFilePanel(B_OPEN_PANEL,
									new BMessenger(this), //target of BMessage
									NULL,
									0,
									false,
									//NULL, //Default msg sent, which is B_REFS_RECEIVED
									new BMessage(B_SIMPLE_DATA),
									NULL,
									false,
									true);
			opendlg->Show();
			break;
		}
		case B_SIMPLE_DATA:
		{
			OpenFile(message);
			break;
		}
		case _SAVEFILE_:
		{	
			SavePrompt();
			break;
		}
		case SAVE_MSG:
		{
			entry_ref ref;
			char name[B_FILE_NAME_LENGTH];
			if(message->FindRef("directory",0,&ref)!=B_OK)
			{
				BAlert* hAlert = new BAlert("About Box:", 
											"Unknown error during save.",	
											"OK",
											NULL,
											NULL,
											B_WIDTH_AS_USUAL,
											(alert_type)B_WARNING_ALERT); 
								
				hAlert->SetShortcut(0, B_ESCAPE); 
				hAlert->Go();
				delete hAlert;
				return;
			}
			strcpy(name,message->FindString("name"));		
			last_saved_as->SetTo(&ref,false);
			BPath savePath(last_saved_as);
			savePath.Append(name,false);
			last_saved_as->SetTo(savePath.Path(),false);
			SaveFile(last_saved_as);
			break;
		}
		case _SAVEAS_:
		{
			was_last_saved=false;
			SavePrompt();
			break;
		}
		default:
			BWindow::MessageReceived(message);
	}
}

void MakPythonViewWindow::SavePrompt()
{
	if (was_last_saved)
		SaveFile(last_saved_as);
	else
	{//create FilePanel to give the user a chance to save his file
		if (!savedlg)
			savedlg=new BFilePanel(B_SAVE_PANEL,
								new BMessenger(this), //target of BMessage
								NULL,
								0,
								false,
								new BMessage(SAVE_MSG), 
								NULL,
								false,
								true);
		savedlg->Show();	
	}		
}

void MakPythonViewWindow::SaveFile(BEntry *saveEnt)
{
	was_last_saved=true;
	BFile saver(saveEnt,B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
	if (exe)
	{
		saver.Write("#!",2);
		saver.Write(path_to_Python,strlen(path_to_Python));
		saver.Write(" ",1);
		saver.Write(clo->Text(),strlen(clo->Text()));
		saver.Write("\n",1);
	}
	saver.Write(Pythonview->Text(),strlen(Pythonview->Text()));
	Set_Title(saveEnt);
	saver.Unset(); //close the file
	BPath savep(saveEnt);
	char sys_call[B_FILE_NAME_LENGTH+9];
	if (exe)
		sprintf(sys_call,"chmod +x %s",savep.Path());
	else
		sprintf(sys_call,"chmod -x %s",savep.Path());
	system(sys_call); 
	
}

void MakPythonViewWindow::OpenFile(BMessage *message)
{
	was_last_saved=false;
	entry_ref ref;
	if(message->FindRef("refs",0,&ref)!=B_OK)
		return;
	BEntry PythonEnt(&ref,false);
	Pref_Saver temp_saver("temp",2);
	char first_line[256+B_PATH_NAME_LENGTH],clops[256]="";
	char *buffer;
	temp_saver.GetLine(&PythonEnt,0,first_line);
	BFile PythonFile(&ref,B_READ_ONLY);
	off_t size;
	PythonFile.GetSize(&size);
	if ((first_line[0]=='#')&&(first_line[1]=='!'))
	{ //ignore first line
		uint i=0;
		while((first_line[i]!=' ')&&(first_line[i]!=0))
		{
			i++;
		}
		if (strlen(first_line)>i+1)
		{
			strncpy(clops,first_line+i,strlen(first_line)-i);
			clops[strlen(first_line)-i]=0;
		}
		buffer=new char[size-strlen(first_line)+1];
		PythonFile.Seek(i+strlen(clops)+1,SEEK_SET);
		PythonFile.Read(buffer,size-strlen(first_line));
		buffer[size-strlen(first_line)]=0;
		clo->SetText(clops);
	}
	else
	{
		buffer=new char[size+1];
		PythonFile.Seek(0,SEEK_SET);
		PythonFile.Read(buffer,size);
		buffer[size]=0;
	}
	Set_Title(&PythonEnt);
	Pythonview->SetText(buffer);
	delete buffer;
	*last_saved_as=PythonEnt;
	was_last_saved=true;
	
}

void MakPythonViewWindow::Set_Title(BEntry *ent)
{
	char title[B_PATH_NAME_LENGTH+20]="MakPythonView -> ";
	char nm[B_PATH_NAME_LENGTH];
	ent->GetName(nm);
	strcat(title,nm);
	SetTitle(title);
}

//Static methods (called to create a new thread)
status_t MakPythonViewWindow::Run_Term(Window_Data *data)
{	
	char syscall[2*B_PATH_NAME_LENGTH+1];
	strcpy(syscall,data->parent->path_to_term);
	strcat(syscall," ");
	strcat(syscall,data->parent->path_to_Python);
	system(syscall);
	data->parent->thread_flag=true;
	return 0;
}

status_t MakPythonViewWindow::Run_Python(Window_Data *data)
{	
	char name[22];
	if (data->call_type)
		strcpy(name,"MakPythonView_Script");
	else
		strcpy(name,"PythonDoc");

	BDirectory pref_subdir("MakPythonView");
	BPath PythonPath;
	BPath contPath;
	if (find_directory(B_USER_SETTINGS_DIRECTORY, &PythonPath)!=B_OK)
    	return 0; 
	BDirectory prefs_dir(PythonPath.Path());
	prefs_dir.CreateDirectory("MakPythonView",&pref_subdir);
	if (PythonPath.Append("MakPythonView")!=B_OK)
		return 0;
	contPath.SetTo(PythonPath.Path());	
	if (PythonPath.Append(name)!=B_OK)
		return 0;
	if (contPath.Append("Container_View")!=B_OK)
		return 0;
	BFile contFile(contPath.Path(),B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
	BFile PythonFile(PythonPath.Path(),B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
			
	contFile.Write("#!",2);
	contFile.Write(data->parent->path_to_sh,strlen(data->parent->path_to_sh));
	contFile.Write("\n",1);
	contFile.Write(PythonPath.Path(),strlen(PythonPath.Path()));
	contFile.Write("\necho \"\nPress <Enter> to continue\"\n",35);
	contFile.Write("read",4);
	contFile.Unset(); //close our small running script.
	char sys_call[B_PATH_NAME_LENGTH];
	sprintf(sys_call,"chmod +x %s",contPath.Path());
	system(sys_call); //Mark the script as executable (required)
	
	PythonFile.Seek(0,SEEK_SET);
	PythonFile.Write("#!",2);
	
	if (data->call_type) //run prog
	{
		PythonFile.Write(data->parent->path_to_Python,strlen(data->parent->path_to_Python));
		PythonFile.Write(" ",1);
		PythonFile.Write(data->parent->clo->Text(),strlen(data->parent->clo->Text()));
		PythonFile.Write("\n",1);
		PythonFile.Write(data->parent->Pythonview->Text(),data->parent->Pythonview->TextLength());
	}
	else //docs!
	{
		PythonFile.Write(data->parent->path_to_sh,strlen(data->parent->path_to_sh));
		PythonFile.Write("\n",1);
		PythonFile.Write(data->parent->path_to_docs,strlen(data->parent->path_to_docs));
		PythonFile.Write(" ",1);
		PythonFile.Write(data->keyword,strlen(data->keyword));
	}
	PythonFile.Write("\n",1);
	
	PythonFile.Unset();
	if (!data->RunFlag)
		return 0;	
	sprintf(sys_call,"chmod +x %s",PythonPath.Path());
	system(sys_call); 
	sprintf(sys_call,"%s %s",data->parent->path_to_term,contPath.Path());
	system(sys_call);
	data->parent->thread_flag=true;
	return 0;
}


