#ifndef _MAKPythonVIEWWINDOW_H_
#define _MAKPythonVIEWWINDOW_H_

#include <Message.h>
#include <Window.h>
#include <TextView.h>
#include <Menu.h>
#include <MenuItem.h>
#include <MenuBar.h>
#include <TextControl.h>
#include <StringView.h>
#include <Box.h>
#include "NewTextView.h"
#include <FilePanel.h>

#define _RUN_Python_ 		'runp'
#define _PREFS_    			'prfs'
#define _EXIT_	   			'exit'
#define _CLEAR_    			'cler'
#define _SCAN_	   			'scan'
#define _TERMINAL_OPEN_ 	'term'
#define _OPENFILE_ 			'opn1'
#define _SAVEFILE_ 			'sav1'
#define _SAVEAS_			'fghj'
#define SAVE_MSG 			'jklo'

class MakPythonViewWindow;

struct Window_Data {
	MakPythonViewWindow	*parent;
	bool				call_type,RunFlag;
	char				keyword[256];
};

class MakPythonViewWindow:public BWindow
{
	public:
						MakPythonViewWindow(BRect frame,bool,bool,bool,bool,char r,char *clops);
		virtual bool	QuitRequested();
		virtual void	MessageReceived(BMessage *message);
		virtual void	FrameResized(float,float);
		void			RestoreEverything(void);
		void			SaveEverything(void);
		void 			OpenFile(BMessage *message);
		void 			SaveFile(BEntry *);
		void 			SavePrompt();
		static	status_t Run_Python(Window_Data*); 
		static	status_t Run_Term(Window_Data*); 
		void 			Set_Title(BEntry *ent);
		
		//preferences: (Get stored even through app death)
		bool			font_is_bold,wrap_text,W_Shown,thread_flag,indented,exe;
		char			path_to_sh[B_PATH_NAME_LENGTH],
						path_to_Python[B_PATH_NAME_LENGTH],
						path_to_term[B_PATH_NAME_LENGTH],
						path_to_docs[B_PATH_NAME_LENGTH],
						run_key;
		
		//controls:
		Window_Data		*data;
		NewTextView		*Pythonview;
		BStringView		*line_num,*pp;
		
	private:
		thread_id		ptn,dcs,trm;
		BMenuBar		*menubar;
		BMenu			*filem,*options,*docs;
		BMenuItem		*runner;	
		BTextControl	*clo;
		BBox			*bg;
		BFilePanel 		*opendlg,*savedlg;
		long			line_number;
		BEntry			*last_saved_as;
		bool			was_last_saved;
};







#endif